<?php

namespace BlueSpice\Discovery;

use MWStake\MediaWiki\Component\CommonUserInterface\LessVars;

class Setup {

	/**
	 *
	 */
	public static function onCallback() {
		self::addBootstrapAssetsToSpecialVersion();

		\mwsInitComponents();

		$GLOBALS['wgUseMediaWikiUIEverywhere'] = true;
		$GLOBALS['wgVisualEditorSupportedSkins'][] = 'bluespicediscovery';
		$GLOBALS['wgVisualEditorSkinToolbarScrollOffset']['bluespicediscovery'] = 100;

		global $wgScriptPath;
		$GLOBALS['wgFavicon'] = "$wgScriptPath/skins/BlueSpiceDiscovery/resources/images/favicon.ico";

		$GLOBALS['wgServiceWiringFiles'][] = dirname( __DIR__ ) . '/includes/ServiceWiring.php';
		$skinSlots = new SkinSlots();
		$skinSlots->init();

		$lessVars = LessVars::getInstance();

		$lessVars->setVar( 'navbar-bg', '#fff' );
		$lessVars->setVar( 'navbar-fg', '#252525' );
		$lessVars->setVar( 'navbar-highlight', '#3e5389' );

		$lessVars->setVar( 'sidebar-bg', '#f1f3f9' );
		$lessVars->setVar( 'sidebar-fg', '#252525' );
		$lessVars->setVar( 'sidebar-highlight', '#3e5389' );

		$lessVars->setVar( 'footer-bg', '#d8d8d9' );
		$lessVars->setVar( 'footer-fg', '#454545' );

		$lessVars->setVar( 'content-bg', '#fff' );
		$lessVars->setVar( 'content-fg', '#252525' );
		$lessVars->setVar( 'link-fg', '#3e5389' );
		$lessVars->setVar( 'new-link-fg', '#bd1d1d' );

		$lessVars->setVar( 'font-weight-light', '300' );
		$lessVars->setVar( 'font-weight-regular', '400' );
		$lessVars->setVar( 'font-weight-medium', '500' );
		$lessVars->setVar( 'font-weight-bold', '700' );

		$lessVars->setVar( 'content-width', '1200px' );
		$lessVars->setVar( 'content-font-size', '15px' );
		$lessVars->setVar( 'content-font-weight', '@font-weight-regular' );
		$lessVars->setVar( 'content-primary-font-family', '"Lato"' );
		$lessVars->setVar( 'content-font-family', '@content-primary-font-family, "sans-serif"' );

		$lessVars->setVar( 'content-h1-fg', '#252525' );
		$lessVars->setVar( 'content-h1-font-size', '2rem' );
		$lessVars->setVar( 'content-h1-font-weight', '500' );
		$lessVars->setVar( 'content-h1-border', 'none' );

		$lessVars->setVar( 'content-h2-fg', '#252525' );
		$lessVars->setVar( 'content-h2-font-size', '1.8rem' );
		$lessVars->setVar( 'content-h2-font-weight', 'bold' );
		$lessVars->setVar( 'content-h2-border', 'none' );

		$lessVars->setVar( 'content-h3-fg', '#252525' );
		$lessVars->setVar( 'content-h3-font-size', '1.6rem' );
		$lessVars->setVar( 'content-h3-font-weight', 'bold' );
		$lessVars->setVar( 'content-h3-border', 'none' );

		$lessVars->setVar( 'content-h4-fg', '#252525' );
		$lessVars->setVar( 'content-h4-font-size', '1.4rem' );
		$lessVars->setVar( 'content-h4-font-weight', 'bold' );
		$lessVars->setVar( 'content-h4-border', 'none' );

		$lessVars->setVar( 'content-h5-fg', '#252525' );
		$lessVars->setVar( 'content-h5-font-size', '1.25rem' );
		$lessVars->setVar( 'content-h5-font-weight', 'bold' );
		$lessVars->setVar( 'content-h5-border', 'none' );

		$lessVars->setVar( 'content-h6-fg', '#252525' );
		$lessVars->setVar( 'content-h6-font-size', '1.1rem' );
		$lessVars->setVar( 'content-h6-font-weight', 'bold' );
		$lessVars->setVar( 'content-h6-border', 'none' );

		$GLOBALS['mwsgWikitextNodeProcessorRegistry'] += \ExtensionRegistry::getInstance()->getAttribute(
			"BlueSpiceDiscoveryEnhancedSidebarNodeProcessors"
		);
	}

	/**
	 * @return void
	 */
	protected static function addBootstrapAssetsToSpecialVersion(): void {
		$path = $GLOBALS['IP'];
		$path .= '/skins/BlueSpiceDiscovery/resources/bootstrap/icons/LICENSE';
		$GLOBALS['wgExtensionCredits']['bluespice-assets'][] = [
			'path' => $path,
			'name' => 'Twitter Bootstrap Icons',
			'license-name' => 'MIT',
			'author' => 'Twitter Bootstrap',
			'url' => 'https://icons.getbootstrap.com',
			'descriptionmsg' => 'bs-discovery-ext-credentials-desc-bootstrap-icons',
			'version' => 'v1.10.3',
		];

		$path = $GLOBALS['IP'];
		$path .= '/skins/BlueSpiceDiscovery/resources/bootstrap/dist/LICENCE';
		$GLOBALS['wgExtensionCredits']['bluespice-assets'][] = [
			'path' => $path,
			'name' => 'Twitter Bootstrap',
			'license-name' => 'MIT',
			'author' => 'Twitter Bootstrap',
			'url' => 'https://getbootstrap.com',
			'descriptionmsg' => 'bs-discovery-ext-credentials-desc-bootstrap-dist',
			'version' => 'v5.3.2',
		];
	}
}
